// src/UsbLcd.hh
// This file is part of SlugTerm; see http://chezphil.org/slugterm
// (C) 2005 Philip Endecott
// Modifications for 4D Systems Display Graphics Modules (C) 2008 Sven Killig <sven@killig.de>

// This is version $Name:  $
//   (if there is no version (e.g. V0-1) mentioned in the previous line,
//    this is probably a snapshot from between "official" releases.)

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#ifndef UsbLcd_hh
#define UsbLcd_hh

extern "C" {
#include <rote/rote.h>
}

#include <string>


class UsbLcd {

public:
  UsbLcd(unsigned int pid, std::string init, std::string fpath, unsigned int fwidth, unsigned int fheight);
  ~UsbLcd();

  void clear(void);
  void home(void);
  void set_mode(bool enable_display,
		bool enable_line_cursor,
		bool enable_block_cursor);
  void set_pos(int row, int col);
  void write(std::string s, unsigned int attr);
  void write(std::string s);
  void write_at(int row, int col, std::string s, unsigned int attr);
  void write_at(int row, int col, std::string s);
  void backlight(bool enable);

  int rows(void) const;
  int cols(void) const;

  void update(void);

private:
  int current_row, current_col;
  bool current_pos_known;
  bool backlight_;

  enum reg { ir=0, dr=1 };
};


#endif
